<template>
	<a-spin :spinning="state.loading" size="large">
        <a-icon slot="indicator" type="loading" spin />
		<div class="row d-flex align-items-center">
			<div class="col-6">
				<h3>
					Изменить профиль сотрудника
				</h3>
			</div>
			<div class="col-6 d-flex justify-content-end">
			    <a-button type="primary" icon="arrow-left" @click="$router.push({ name: 'userPage', params: {id: $route.params.id} })">Назад</a-button>
			</div>
			<div class="col-12" v-if="right">
				<form>
					<div class="row">
						<div class="col-12">
							<div class="form-group">
								<label>
									Отдел <span class="text-danger">*</span>
									<div class="pt-3">
										<a-radio-group @change="changeDepartment" v-model="user.department" v-for="dep in departments" :key="dep.id">
									    	<a-radio :style="radioStyle" :value="dep.id">{{ dep.name }}</a-radio>
									  	</a-radio-group>
									</div>
								</label>
							</div>
						</div>
						<div class="col-6">
							<div class="form-group">
								<label>
									Логин <span class="text-danger">*</span>
								</label>
								<a-input placeholder="Введите логин сотрудника" v-model="user.email" />
							</div>
						</div>
						<div class="col-6">
							<div class="form-group">
								<label>
									Email <span class="text-danger">*</span>
								</label>
								<a-input placeholder="Введите email сотрудника" v-model="user.work_email" />
							</div>
						</div>
						<div class="col-6">
							<div class="form-group">
								<label>
									Фамилия <span class="text-danger">*</span>
								</label>
								<a-input placeholder="Введите Фамилию сотрудника" v-model="user.l_name" />
							</div>
						</div>
						<div class="col-6">
							<div class="form-group">
								<label>
									Имя <span class="text-danger">*</span>
								</label>
								<a-input placeholder="Введите фамилию имя сотрудника" v-model="user.f_name" />
							</div>
						</div>
						<div class="col-6">
							<div class="form-group">
								<label>
									Отчество
								</label>
								<a-input placeholder="Введите отчество сотрудника" v-model="user.m_name" />
							</div>
						</div>
						<div class="col-6">
							<div class="form-group">
								<label>
									Мобильный телефон
								</label>
								<a-input placeholder="Введите мобильный телефон сотрудника" v-model="user.mob_phone" />
							</div>
						</div>
						<div class="col-6">
							<div class="form-group">
								<label>
									Рабочий телефон
								</label>
								<a-input placeholder="Введите рабочий телефон сотрудника" v-model="user.work_phone" />
							</div>
						</div>
						<div class="col-6">
							<div class="form-group">
								<label>
									Должность
								</label>
								<a-input placeholder="Введите должность сотрудника" v-model="user.position" />
							</div>
						</div>
					</div>
					<div class="form-group">
						<a-button type="primary" @click="prepareData">Отправить</a-button>
					</div>
				</form>
				<hr/>
				<h3>
					Изменить пароль
				</h3>
				<form>
					<div class="form-group">
						<label>
							Новый пароль <a href="javascript:void(0)" @click="setDefaultPassword">поставить по умолчанию</a>
						</label>
						<a-input placeholder="Введите новый пароль" v-model="newPassword" />
					</div>
					<div class="form-group">
						<a-button type="primary" @click="setNewPassword">Отправить</a-button>
					</div>
				</form>
				<hr/>
				<h3>
					Изменить фото
				</h3>
				<div class="mt-3">
					<div class="form-group">
						<input type="file" id="file" ref="file" v-on:change="handleAvatarUpload"/>
					</div>
					<div class="form-group">
						<a-button type="primary" @click="submitAvatar">Отправить</a-button>
					</div>
				</div>
			</div>
			<div v-else>
				<a-alert message="У вас нет прав на эту операцию" type="error" />
			</div>
		</div>
	</a-spin>
</template>

<script type="text/javascript">
	function getBase64 (img, callback) {
	  const reader = new FileReader()
	  reader.addEventListener('load', () => callback(reader.result))
	  reader.readAsDataURL(img)
	}

	export default {
		data () {
			return {
				avatar: '',
				user: '',
				radioStyle: {
			        display: 'block',
			        height: '30px',
			        lineHeight: '30px',
			    },
				departments: '',
				right: false,
				state: {
					loading: false
				},
				newPassword: ''
			}
		},
		created () {
			this.$http.get(this.$store.state.api.url+'getUser/'+this.$route.params.id)
			.then(this.loadUserSuccess,this.loadUserError);
			this.$http.get(this.$store.state.api.url+'getAllDepartments')
			.then(this.loadDepartmentsSuccess,this.loadDepartmentsError);
			let scopes = JSON.parse(this.$store.state.user.scopes);
			for (var i = scopes.length - 1; i >= 0; i--) {
				if (scopes[i] === '*' || scopes[i] === 'usersRight') {
					this.right = true
				}
			}
		},
		methods: {
			prepareData () {
				if (this.user.department === '') {
					this.$message.error('Выберите отдел');
					return false;
				}
				if (this.user.work_email === '') {
					this.$message.error('Введите email сотрудника');
					return false;
				}
				if (this.user.email === '') {
					this.$message.error('Введите логин сотрудника');
					return false;
				}
				if (this.user.password === '') {
					this.$message.error('Введите пароль сотрудника');
					return false;
				}
				if (this.user.l_name === '') {
					this.$message.error('Введите фамилию сотрудника');
					return false;
				}
				if (this.user.f_name === '') {
					this.$message.error('Введите имя сотрудника');
					return false;
				}

				this.updateUser(this.user);
			},
			changeDepartment (e) {
				this.user.department = e.target.value;
				console.log(this.user.department)
			},
			loadDepartmentsSuccess (res) {
				this.departments = res.body;
			},
			loadUserSuccess (res) {
				this.user = res.body;
				this.user.department = this.user.department.id;
				this.user.id = this.$route.params.id;

			},
			loadUserError (err) {
				console.log(err)
			},
			updateUser (data) {
				this.$http.post(this.$store.state.api.url+'updateUser', data)
				.then(this.updateUserSuccess,this.updateUserError);
			},
			updateUserSuccess (res) {
				this.$message.success('Сотрудник изменен');
				this.$router.push({ name: 'UsersPage' });
				console.log(res.body)
			},
			updateUserError (err) {
				console.log(err);
				this.$message.error('Во время выполнения операции произошла ошибка. Обратитесь к администратору!');
				return false;
			},
			setDefaultPassword () {
				this.newPassword = this.$store.state.password_default;
			},
			setNewPassword () {
				if (this.newPassword === '') {
					this.$message.error('Введите новый пароль!');
					return false;
				}
				let data = {
					id: this.$route.params.id,
					password: this.newPassword
				}
				this.$http.post(this.$store.state.api.url+'updatePassword', data)
				.then(this.updatePasswordSuccess, this.updatePasswordError);
			},
			updatePasswordSuccess (res) {
				this.$message.success('Пароль изменен');
				this.$router.push({ name: 'UsersPage' });
			},
			updatePasswordError (err) {
				console.log(err);
			},
			handleAvatarUpload () {
				this.avatar = this.$refs.file.files[0];
			},
			submitAvatar () {
				let formData = new FormData();
				formData.append('avatar', this.avatar);
				this.$http.post(this.$store.state.api.url+'updateAvatar/'+this.$route.params.id, formData, {
				    headers: {
				        'Content-Type': 'multipart/form-data'
				    }
				}).then(this.updateAvatarSuccess, this.updateAvatarError);
			},
			updateAvatarSuccess (res) {
				this.$message.success('Фото обновлено');
				this.$router.push({ name: 'userPage', params: {id: this.$route.params.id} });
			},
			updateAvatarError (err) {
				console.log(err);
			}
		}
	} 
</script>

<style>
  .avatar-uploader > .ant-upload {
    width: 128px;
    height: 128px;
  }
  .ant-upload-select-picture-card i {
    font-size: 32px;
    color: #999;
  }

  .ant-upload-select-picture-card .ant-upload-text {
    margin-top: 8px;
    color: #666;
  }
</style>